import { getQueryString } from './Url'

// -----------
// ----------- 环境判断类 ----------
// -----------
const USERAGENT = window.navigator.userAgent
//判断微信
export const isWeixin = () => {
  const ua: any = USERAGENT.toLowerCase();
  return ua.match(/MicroMessenger/i) == 'micromessenger'
}
// 判断安卓
export const isAndroid = () => {
  return USERAGENT.indexOf('Android') > -1 || USERAGENT.indexOf('Linux') > -1; //g
}
// 判断ios
export const isIos = () => {
  return !!USERAGENT.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
}
// 判断是否是在 App 中
export const isApp = () => {
  return USERAGENT.indexOf('com.xike.app') > -1
}

export const isPc = () => {
  var userAgentInfo = navigator.userAgent;
  var Agents = new Array("Android", "iPhone", "SymbianOS", "Windows Phone", "iPad", "iPod");
  var flag = true;
  for (var v = 0; v < Agents.length; v++) {
    if (userAgentInfo.indexOf(Agents[v]) > 0) {
      flag = false;
      break;
    }
  }
  // pc true phone false
  return flag;
}

// 获取滚动高度
export const getScroll = (win: any, top: any) => {
  // window.pageXOffset 
  let ret = win[`page${top ? 'Y' : 'X'}Offset`];
  const method = `scroll${top ? 'Top' : 'Left'}`;
  if (typeof ret !== 'number') {
    const d = win.document;
    // documentElement
    ret = d.documentElement[method];
    if (typeof ret !== 'number') {
      // body
      ret = d.body[method];
    }
  }
  return ret;
}

// body 禁止滚动
const preventDefaultFunc = function (e: any) {
  e.preventDefault()
}
export const setBodyScroll = (isAllow: any) => {
  const _body = document.body
  if (isAllow) {
    // _body.style.overflow = 'unset' 
    _body.removeEventListener('touchmove', preventDefaultFunc)
    return
  }
  // _body.style.overflow = 'hidden' 
  _body.addEventListener('touchmove', preventDefaultFunc, { passive: false })
}

// 自动下载时间啊
export const DOWN_MS = 500000
let maskInstance = null
let certInstance = null
// 下载
// 本地数据 sessionStorage 在layout中统一存入
// 苹果证书下载地址
const certUrl = 'https://starbuds.paqukeji.com/embedded.mobileprovision'

//app下载地址统一
const c = getQueryString('c') || getQueryString('ci') || '0'
export const _appDownloadUrl = `http://starbuds.paqukeji.com/download/${c}` + '?s=1'
//增加渠道号 http://starbuds.paqukeji.com/download/渠道号, 主包是0
